package applications;

import java.util.*;

public class bezierSegment {

  private point p1, p2, p3, p4;
  private point[] points = null;
  
  private double thresholdFactor = 1;
  private double threshold;
  
  public void setPoints(point p1, point p2, point p3, point p4) {
    this.p1 = p1;
    this.p2 = p2;
    this.p3 = p3;
    this.p4 = p4;
    points = null;
  }
  
  public void toPolyline(double resolution, Vector collect) {
    threshold = thresholdFactor * resolution * resolution;
    polyline(p1, p2, p3, p4, collect);
  }
  
  private void polyline(point p1, point p2, point p3, point p4, Vector collect) {
    if (isFlat(p1, p4, p2) && isFlat(p1, p4, p3)) collect.addElement(p4);
    else {
      double hx = (p2.x + p3.x) / 2;
      double hy = (p2.y + p3.y) / 2;
      point l2 = new point((p1.x+p2.x)/2, (p1.y + p2.y)/2);
      point l3 = new point((l2.x+hx)/2, (l2.y + hy)/2);
      point r3 = new point((p3.x+p4.x)/2, (p3.y + p4.y)/2);
      point r2 = new point((r3.x+hx)/2, (r3.y + hy)/2);
      point m = new point((l3.x+r2.x)/2, (l3.y + r2.y)/2);
      polyline(p1, l2, l3, m, collect);
      polyline(m, r2, r3, p4, collect);
    }
  }
  
  private boolean isFlat(point p1, point p2, point q) {
    double X = p2.x - p1.x;
    double Y = p2.y - p1.y;
    if (X == 0) return sqr(q.x - p1.x) <= threshold;
    if (Y == 0) return sqr(q.y - p1.y) <= threshold;
    double XdivY = X / Y;
    double YdivX = Y / X;
    double intersectX = (q.y - p1.y + YdivX * p1.x + XdivY * q.x) / (XdivY + YdivX);
    double intersectY = p1.y + YdivX * (intersectX - p1.x);
    return sqr(q.x - intersectX) + sqr(q.y - intersectY) <= threshold;
  }
  
  private double sqr(double d) {
    return d * d;
  }
  
}
