package applications.collages;

import java.util.*;

public class ccOperation {

  public float[] rgbFactor = new float[3];
  public float[] rgbDest   = new float[3];
  public boolean[] rgbFlip = new boolean[3];
  
  private ccOperation() { }

  public static ccOperation decode(String name) {
    if (name.toLowerCase().startsWith("rgb(") && name.endsWith(")")) {
      name = name.substring(4, name.length()-1);
    }
    else return null;
    if (name.indexOf(',') == -1) name = name + ',' + name + ',' + name + ',';
    else name = name + ',';
    ccOperation result = new ccOperation();
    for (int i = 0; i < 3; i++) {
      try {
        name = name.trim();
        int sep;
        if (name.startsWith("-")) {
          result.rgbFactor[i] = 0;
          result.rgbDest[i] = 0;
          result.rgbFlip[i] = false;
          if ((sep = name.indexOf(',')) == -1) return null;
        }
        else {
          sep = name.indexOf(':');
          result.rgbFlip[i] = (name.indexOf("::") == sep);
          if (sep == -1) return null;
          result.rgbFactor[i] = Float.valueOf(name.substring(0,sep)).floatValue();
          if (result.rgbFlip[i]) name = name.substring(sep+2); else name = name.substring(sep+1);
          if ((sep = name.indexOf(',')) == -1) return null;
          result.rgbDest[i] = Float.valueOf(name.substring(0,sep)).floatValue();
          if (result.rgbFactor[i] < 0 || result.rgbFactor[i] > 1 ||
              result.rgbDest[i] < 0 || result.rgbDest[i] > 1) return null;
        }
        name = name.substring(sep+1);
      }
      catch (NumberFormatException e) { return null; }
    }
    if (name.length() == 0) return result;
    else return null;
  }
  
}
