package applications.collages;

import java.util.*;
import parsers.*;
import terms.*;
import algebras.*;
import applications.*;

public class collageAlgebra extends extensibleAlgebra {

  protected Object apply(symbol s, Object[] args) {
    Object o = operationOf(s);
    if (o == null) return null;
    if (o instanceof collage) try { return ((collage)o).clone(); } catch (CloneNotSupportedException e) {}
    if (o instanceof Object[]) {
      Object[] ops = (Object[])o;
      collage result = new collage();
      int argNum = 0;
      for (int i = 0; i < ops.length; i++) {
        if (ops[i] instanceof collage) {
          Object c = null;
          try { c = ((collage)ops[i]).clone(); } catch (CloneNotSupportedException e) {}
          result.unionWith((collage)c);
        }
        else if (ops[i] instanceof transformation) {
          if (args[argNum] instanceof collage) {
            collage arg = (collage)args[argNum++];
            arg.transform((transformation)ops[i]);
            result.unionWith(arg);
          }
          else return null;
        }
        else return null;
      }
      return result;
    }
    if (o instanceof ccOperation) {
      if (args[0] instanceof collage) {
        ((collage)args[0]).changeColours((ccOperation)o);
        return args[0];
      }
    }
    return null;
  }
  
  protected Object extendBy(symbol s) {
    affine[] result = new affine[s.rank()];
    for (int i = 0; i < s.rank(); i++) result[i] = new affine();
    return result;
  }

/** Initialize a <code>collageAlgebra</code> by reading its definition from a stream.
  * @see collageAlgebraParser
  * @exception ParseException if an error occurs
  */
  public void parse(ASCII_CharStream stream) throws ParseException {
    setParser parser = new setParser(stream);
    parser.set(new collageAlgebraParser(stream, this));
  }

  
}
