package applications.collages;

import java.awt.*;
import applications.*;

public abstract class part implements Cloneable {

  public boolean shown = false;  // used by collageDisplay to indicate whether
                                 // part intersects window
  private Color colour = null;
  private float r = 0;
  private float g = 0;
  private float b = 0;
  private double thickness = -1;

  public void setColour(float R, float G, float B) {
    colour = null; r = R; g = G; b = B;
  }
  
  public void setColour(Color c) {
    colour = c;
    r = (float)c.getRed()/255;
    g = (float)c.getGreen()/255;
    b = (float)c.getBlue()/255;
  }
  
  public Color getColour() {
    if (colour == null) return colour = new Color(r,g,b); else return colour;
  }
  
  public void setThickness(double thickness) {
    this.thickness = thickness;
  }
  
  public double getThickness() {
    return thickness;
  }

  public abstract void transform(transformation t);
  
  public void changeColour(ccOperation op) {
    setColour(modify(r, op.rgbFactor[0], op.rgbDest[0], op.rgbFlip[0]),
              modify(g, op.rgbFactor[1], op.rgbDest[1], op.rgbFlip[1]),
              modify(b, op.rgbFactor[2], op.rgbDest[2], op.rgbFlip[2]));
  }
  
  private float modify(float origValue, float factor, float dest, boolean flip) {
    if (flip) origValue = 1 - origValue;
    return origValue + factor * (dest - origValue);
  }
  
  public abstract double[] bounds();
  
  public Object clone() throws CloneNotSupportedException {
    return (part)super.clone();
  }

}
