package applications.collages;

import java.awt.*;
import applications.*;

public class polyPart extends part {

  public static int filledPolygon = 0;
  public static int polygon = 1;
  public static int polyline = 2;

  private int type;
  private point[] points = new point[0];
  
  public polyPart(int type) {
    this.type = type;
  }
  
  public int getType() { return type; }
  
  public void addPoint(point p) {
    point[] newPoints = new point[points.length + 1];
    System.arraycopy(points, 0, newPoints, 0, points.length);
    newPoints[points.length] = p;
    points = newPoints;
  }
  
  public void transform(transformation t) {
    for (int i = 0; i < points.length; i++) t.transform(points[i]);
  }
  
  public point[] getPoints() { return points; }
  
  public double[] bounds() {
    point[] points = getPoints();
    double[] bounds = new double[4];
    bounds[0] = bounds[2] = points[0].x;
    bounds[1] = bounds[3] = points[0].y;
    for (int i = 1; i < points.length; i++) {
      point p = points[i];
      if (p.x < bounds[0]) bounds[0] = p.x;
      if (p.y < bounds[1]) bounds[1] = p.y;
      if (p.x > bounds[2]) bounds[2] = p.x;
      if (p.y > bounds[3]) bounds[3] = p.y;
    }
    return bounds;
  }    
  
  public Object clone() throws CloneNotSupportedException {
    polyPart result = (polyPart)super.clone(); 
    result.points = new point[points.length];
    for (int i = 0; i < points.length; i++) result.points[i] = new point(points[i].x, points[i].y);
    return result;
  }
  
}
