package gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import gui.nodeTypes.*;
import util.*;

public class commandPanel extends JFrame {

  private Panel p = new Panel();
  private list currentCommands = new list();
  private worksheetNode notify;
  
  public commandPanel(worksheetNode notify) {
    super(notify.getName());
    this.notify = notify;
    getContentPane().add(p);
  }
  
  public void setCommands(list commands) {
    if (!comp.compare(currentCommands,commands)) {
      currentCommands = (list)commands.clone();
      p.removeAll();
      p.setLayout(new GridLayout(0,1,0,0));
      while (!commands.isEmpty()) {
        Panel row = new Panel();
        row.setLayout(new GridLayout(1, 0));
        p.add(row);
        String[] command = (String[])commands.head();
        for (int i = 0; i < command.length; i++) {
          Button button = new Button(command[i]);
          button.addActionListener(notify);
          row.add(button);
        }
        commands = commands.tail();
      }
      pack();
    }
  }
  
  public void dispose() {
    notify = null;
    p = null;
    super.dispose();
  }
    
}
