package gui.nodeTypes;

import java.util.*;
import java.awt.*;
import terms.*;
import generators.*;
import parsers.*;

public class termGeneratorNode extends worksheetNode {

  private static int l = radius/10;
  private static int a = radius/3;
  private static int [] iconX = { a, a, l, l, a, 0, -a, -l, -l, -a, -a };
  private static int []
    iconY = {-radius-2*l+2*a,-radius+2*a,-radius+2*a,radius-2*a,radius-2*a,
             radius,
             radius-2*a,radius-2*a,-radius+2*a,-radius+2*a,-radius-2*l+2*a };
  
  protected term curr = null;

  public termGeneratorNode(termGenerator gen, String fileName) {
    super(gen, fileName);
    figureX = iconX;
    figureY = iconY;
  }
  
  public void initialize() throws ParseException {
    curr = ((termGenerator)contents).currentTerm();
  }
  
  public synchronized term currentTerm() { return curr; }
  
  public boolean acceptsSource(worksheetNode source) {
    return acceptable(source) && super.acceptsSource(source);
  }
      
  protected boolean acceptable(worksheetNode source) { return false; }
  
  public void runContents(Object command, int type) {
    super.runContents(command, type);
    setChanged();
    synchronized (this) { curr = ((termGenerator)contents).currentTerm(); }
    broadcastResult(curr);
  }
  
  protected void reinit(parsable newContents) {
    super.reinit(newContents);
    curr = ((termGenerator)contents).currentTerm();
  }
  
  public void ping() {
    broadcastResult(curr);
  }
  
}
