package gui.nodeTypes;

import java.util.*;
import java.awt.*;
import terms.*;
import generators.*;
import gui.*;
import parsers.*;
import util.*;

public class termModifierNode extends termGeneratorNode {

  private static int l = radius/10;
  private static int a = radius/3;
  private static int [] iconX = { l, l, a, 0, -a, -l, -l };
  private static int [] iconY = { -radius+l, radius-2*a, radius-2*a,
                                  radius, radius-2*a, radius-2*a, -radius+l };
                                  
  private edge inputEdge = null;

  public termModifierNode(termModifier mod, String fileName) {
    super(mod, fileName);
    figureX = iconX;
    figureY = iconY;
  }
  
  protected boolean acceptable(worksheetNode source) {
    return source instanceof termGeneratorNode;
  }
  
  public void sourceEstablished(edge e) {
    if (inputEdge != null) parent().deleteEdge(inputEdge);
    inputEdge = e;
    termGeneratorNode source = (termGeneratorNode)e.source;
    transferCommand(source.currentTerm(), TERM);
  }
  
  public void runContents(Object command, int type) {
    if (type == TERM) {
      term result;
      if (command == null) result = null;
      else result = ((termModifier)contents).apply((term)command);
      synchronized (this) { curr = result; }
      broadcastResult(result);
    }
    else super.runContents(command, type);
  }
  
  public void sourceDeleted(edge e) {
    inputEdge = null;
    transferCommand(null, TERM);
  }
  
  public void ping() {
    term input = null;
    if (inputEdge != null) {
      termGeneratorNode source = (termGeneratorNode)inputEdge.source;
      input = source.currentTerm();
    }
    transferCommand(input, TERM);
  }
  
}
