/* Generated By:JavaCC: Do not edit this line. YIELDAlgebraParser.java */
package parsers;

import java.util.*;
import terms.*;
import algebras.*;

public class YIELDAlgebraParser implements componentParser, YIELDAlgebraParserConstants {

  private ASCII_CharStream inputStream = null;
  private setParser definitions;
  private nameParser names;
  private symbolParser symbols;
  private YIELDAlgebra alg;
  private Hashtable synonyms = new Hashtable();

  public YIELDAlgebraParser(ASCII_CharStream input) {
    this(new YIELDAlgebraParserTokenManager(input));
    names = new nameParser(input);
    symbols = new symbolParser(input);
    definitions = new setParser(input);
    inputStream = input;
  }

/** Parse a <code>YIELDAlgebra</code>.
  * The syntax requires a set of equations defining synonyms for the standard symbols.
  * @exception ParseException if an error occurs
  */
  final public void YIELDAlgebra(YIELDAlgebra alg) throws ParseException {
  this.alg = alg;
    definitions.set(this);
  }

  final public void component() throws ParseException {
    String lhsName = names.name();
    jj_consume_token(EQUALS);
    symbol rhs = symbols.symbol();
    symbol lhs = new symbol(lhsName, rhs.rank());
    if (alg.extendBy(lhs) != null) {
      {if (true) throw new ParseException("Symbol " + lhs + " of rank " +
                                                   lhs.rank() + " has a standard meaning." +
                                                   " Such symbols cannot be used as synonyms");}
    }
    if (synonyms.get(lhs)  != null) {
      {if (true) throw new ParseException("Symbol " + lhs + " of rank " + lhs.rank() +
                                                 " already used as a synonym for " +
                                                 synonyms.get(lhs) + ".\nYou cannot use it" +
                                                 " for " + rhs + " at the same time");}
    }
    synonyms.put(lhs,rhs);
    Object meaning = alg.extendBy(rhs);
    if (meaning == null) {
      {if (true) throw new ParseException("Cannot introduce a synonym for " + rhs + " of rank " +
                                                  rhs.rank() + ": this symbol has no standard meaning");}
    }
    alg.defineSymbol(lhs, meaning);
  }

  public YIELDAlgebraParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[0];
  final private int[] jj_la1_0 = {};

  public YIELDAlgebraParser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new YIELDAlgebraParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
  }

  public YIELDAlgebraParser(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new YIELDAlgebraParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
  }

  public YIELDAlgebraParser(YIELDAlgebraParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
  }

  public void ReInit(YIELDAlgebraParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[7];
    for (int i = 0; i < 7; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 0; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 7; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
