/* Generated By:JavaCC: Do not edit this line. collageAlgebraParser.java */
package parsers;

import java.util.*;
import java.awt.*;
import applications.collages.*;
import applications.*;
import terms.*;
import util.*;

public class collageAlgebraParser implements componentParser, collageAlgebraParserConstants {

  private nameParser names;
  private Hashtable nameTable = new Hashtable();
  private Hashtable constTable = new Hashtable();
  private Hashtable colTable = new Hashtable();
  private ASCII_CharStream inputStream = null;
  private collageAlgebra result;

  public collageAlgebraParser(ASCII_CharStream input, collageAlgebra result) {
    this(new collageAlgebraParserTokenManager(input));
    names = new nameParser(input);
    this.result = result;
    inputStream = input;
  }

  private Object[] array(list components) {
    Object[] result = new Object[components.length()];
    for (int i = 0; i < result.length; i++) {
      result[i] = components.head();
      components = components.tail();
    }
    return result;
  }

  private affine linearMapping(double a, double b, double a2, double b2,
                                                             double c, double d, double c2, double d2)
  throws ParseException {
    affine result = affine.linear(a,b,a2,b2,c,d,c2,d2);
    if (result == null) throw
      new ParseException("vectors (" + a + ", " + b + ") and (" + c + ", " + d + ") linearly dependent");
    return result;
  }

  private affine affineMapping(double a, double b, double a2, double b2,
                                                             double c, double d, double c2, double d2,
                                                             double e, double f, double e2, double f2)
  throws ParseException {
    affine result = affine.affine(a,b,a2,b2,c,d,c2,d2,e,f,e2,f2);
    if (result == null) throw
      new ParseException("vectors linearly dependent");
    return result;
  }

  private affine similarity(double a, double b, double a2, double b2,
                                                             double c, double d, double c2, double d2)
  throws ParseException {
    affine result = affine.similarity(a,b,a2,b2,c,d,c2,d2);
    if (result == null)
      throw new ParseException("pre-images must not be identical");
    return result;
  }

  private collage lookup(String name) throws ParseException {
    Object o = colTable.get(name);
    if (o == null) throw new ParseException("Collage '" + name + "' undefined");
    collage c = (collage)o;
    try { return ((collage)c.clone()); }
    catch (CloneNotSupportedException e) {
      throw new InternalError();
    }
  }

  final public void component() throws ParseException {
  String name;
  collage col = new collage();
  transformation trans;
  Object[] op;
  ccOperation cc;
  double d;
    name = names.name();
    jj_consume_token(EQUALS);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONST:
      jj_consume_token(CONST);
      jj_consume_token(LEFT_PAR);
      d = expr();
      jj_consume_token(RIGHT_PAR);
      if (constTable.put(name, new Double(d)) != null) {
        {if (true) throw new ParseException("constant " + name + " defined twice");}
      }
      break;
    case LEFT_BRACE:
    case USECONST:
      collageUnion(col);
      if (result.defineSymbol(new symbol(name, 0), col) != null) {
        {if (true) throw new ParseException("constant " + name + " defined twice");}
      }
      colTable.put(name, col);
      break;
    case ROT:
    case SCALE:
    case TRANS:
    case MATRIX:
    case MAP:
    case SIM:
    case USETRANS:
      trans = composedTransformation(new affine());
      if (nameTable.put(name, trans) != null) {
        {if (true) throw new ParseException("transformation " + name + " defined twice");}
      }
      break;
    case OP_BRACKET_LEFT:
      op = operation();
      int arity = 0;
      for (int i = 0; i < op.length; i++) if (op[i] instanceof transformation) arity++;
      if (result.defineSymbol(new symbol(name, arity), op) != null) {
        if (arity == 0) {if (true) throw new ParseException("constant " + name + " defined twice");}
        else {if (true) throw new ParseException("operation " + name + " defined twice");}
      }
      break;
    case CC:
      cc = ccOperation();
      if (result.defineSymbol(new symbol(name, 1), cc) != null) {
        {if (true) throw new ParseException("operation " + name + " defined twice");}
      }
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void collageUnion(collage col) throws ParseException {
  affine trans = null;
  collage tmp = new collage();
    collage(tmp);
    token_source.SwitchTo(AFTER_COLLAGE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRANSFORMED2:
      jj_consume_token(TRANSFORMED2);
      jj_consume_token(BY2);
      trans = transByName();
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
      if (trans != null) tmp.transform(trans);
      col.unionWith(tmp);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IS_UNION:
      jj_consume_token(IS_UNION);
      collageUnion(col);
      break;
    case NOTHING:
      jj_consume_token(NOTHING);
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void collage(collage col) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFT_BRACE:
      jj_consume_token(LEFT_BRACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case POLYGON:
      case POLYLINE:
      case FILLED_POLYGON:
      case CURVE:
      case FILLED_CURVE:
      case CLOSED_CURVE:
      case POINT:
        parts(col);
        break;
      default:
        jj_la1[3] = jj_gen;
        ;
      }
      jj_consume_token(RIGHT_BRACE);
      break;
    case USECONST:
      jj_consume_token(USECONST);
               col.unionWith(lookup(names.name()));
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void parts(collage col) throws ParseException {
  part p;
  affine trans = null;
  collage ncol;
    p = part();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRANSFORMED:
      jj_consume_token(TRANSFORMED);
      jj_consume_token(BY);
      trans = transByName();
      break;
    default:
      jj_la1[5] = jj_gen;
      ;
    }
    if (trans != null) p.transform(trans);
    col.add(p);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      parts(col);
      break;
    default:
      jj_la1[6] = jj_gen;
      ;
    }
  }

  final public part part() throws ParseException {
  part p;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case POINT:
      jj_consume_token(POINT);
      jj_consume_token(LEFT_PAR);
      p = dot();
      jj_consume_token(RIGHT_PAR);
      break;
    case POLYGON:
    case POLYLINE:
    case FILLED_POLYGON:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case POLYGON:
        jj_consume_token(POLYGON);
                  p = new polyPart(polyPart.polygon);
        break;
      case POLYLINE:
        jj_consume_token(POLYLINE);
                   p = new polyPart(polyPart.polyline);
        break;
      case FILLED_POLYGON:
        jj_consume_token(FILLED_POLYGON);
                         p = new polyPart(polyPart.filledPolygon);
        break;
      default:
        jj_la1[7] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(LEFT_PAR);
      polygon((polyPart)p);
      jj_consume_token(RIGHT_PAR);
      break;
    case CURVE:
    case FILLED_CURVE:
    case CLOSED_CURVE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CURVE:
        jj_consume_token(CURVE);
                p = new bezierPart(bezierPart.curve);
        break;
      case FILLED_CURVE:
        jj_consume_token(FILLED_CURVE);
                       p = new bezierPart(bezierPart.filledCurve);
        break;
      case CLOSED_CURVE:
        jj_consume_token(CLOSED_CURVE);
                       p = new bezierPart(bezierPart.closedCurve);
        break;
      default:
        jj_la1[8] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(LEFT_PAR);
      curve((bezierPart)p);
      jj_consume_token(RIGHT_PAR);
      break;
    default:
      jj_la1[9] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFT_BRACKET:
      jj_consume_token(LEFT_BRACKET);
                     p.setColour(rgb());
      jj_consume_token(RIGHT_BRACKET);
      break;
    default:
      jj_la1[10] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case WIDTH:
      jj_consume_token(WIDTH);
      double w = expr();
      if (w < 0) {if (true) throw new ParseException("Negative line width " + w);}
      p.setThickness(w);
      break;
    default:
      jj_la1[11] = jj_gen;
      ;
    }
    {if (true) return p;}
    throw new Error("Missing return statement in function");
  }

  final public dot dot() throws ParseException {
  double x;
  double y;
    x = expr();
    jj_consume_token(COMMA);
    y = expr();
    {if (true) return new dot(x, y);}
    throw new Error("Missing return statement in function");
  }

  final public void polygon(polyPart p) throws ParseException {
  double x;
  double y;
    jj_consume_token(LEFT_PAR);
    x = expr();
    jj_consume_token(COMMA);
    y = expr();
    jj_consume_token(RIGHT_PAR);
    p.addPoint(new point(x, y));
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      polygon(p);
      break;
    default:
      jj_la1[12] = jj_gen;
      ;
    }
  }

  final public void curve(bezierPart p) throws ParseException {
    curvePoint(p);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      curve(p);
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
  }

  final public void curvePoint(bezierPart p) throws ParseException {
  double lx, ly, rx, ry, px, py;
  lx = ly = rx = ry = 0;
    jj_consume_token(LEFT_PAR);
    px = expr();
    jj_consume_token(COMMA);
    py = expr();
    jj_consume_token(RIGHT_PAR);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFT:
    case RIGHT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEFT:
        jj_consume_token(LEFT);
        jj_consume_token(LEFT_PAR);
        lx = expr();
        jj_consume_token(COMMA);
        ly = expr();
        jj_consume_token(RIGHT_PAR);
      rx = -lx; ry = -ly;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case RIGHT:
          jj_consume_token(RIGHT);
          jj_consume_token(LEFT_PAR);
          rx = expr();
          jj_consume_token(COMMA);
          ry = expr();
          jj_consume_token(RIGHT_PAR);
          break;
        default:
          jj_la1[14] = jj_gen;
          ;
        }
        break;
      case RIGHT:
        jj_consume_token(RIGHT);
        jj_consume_token(LEFT_PAR);
        rx = expr();
        jj_consume_token(COMMA);
        ry = expr();
        jj_consume_token(RIGHT_PAR);
      lx = -rx; ly = -ry;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LEFT:
          jj_consume_token(LEFT);
          jj_consume_token(LEFT_PAR);
          lx = expr();
          jj_consume_token(COMMA);
          ly = expr();
          jj_consume_token(RIGHT_PAR);
          break;
        default:
          jj_la1[15] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[16] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[17] = jj_gen;
      ;
    }
    p.addPoint(new point(px + lx, py + ly),
                 new point(px, py),
                 new point(px + rx, py + ry));
  }

  final public Color rgb() throws ParseException {
  double red;
  double green;
  double blue;
    red = expr();
    jj_consume_token(COMMA);
    green = expr();
    jj_consume_token(COMMA);
    blue = expr();
    try { {if (true) return new Color((float)red, (float)green, (float)blue);} }
    catch ( IllegalArgumentException e )
    { {if (true) throw new ParseException("rgb value [" + red + ", " + green + ", " + blue + "] out of range");} }
    throw new Error("Missing return statement in function");
  }

  final public affine composedTransformation(affine previous) throws ParseException {
  affine trans;
    trans = transformation();
    previous.composeWith(trans);
    token_source.SwitchTo(COMPOSE_OR_NOT);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IS_COMPOSE:
      jj_consume_token(IS_COMPOSE);
      composedTransformation(previous);
      break;
    case NOT_COMPOSE:
      jj_consume_token(NOT_COMPOSE);
      break;
    default:
      jj_la1[18] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return previous;}
    throw new Error("Missing return statement in function");
  }

  final public affine transformation() throws ParseException {
  affine trans;
  double a; double b; double c; double d; double e = 0; double f = 0;
  double a2; double b2; double c2; double d2; double e2 = 0; double f2 = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case USETRANS:
      trans = usedTrans();
      break;
    case ROT:
      jj_consume_token(ROT);
      jj_consume_token(LEFT_PAR);
      a = expr();
      jj_consume_token(RIGHT_PAR);
      trans = affine.rotation(a/180 * Math.PI);
      break;
    case SCALE:
      jj_consume_token(SCALE);
      jj_consume_token(LEFT_PAR);
      a = expr();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RIGHT_PAR:
        jj_consume_token(RIGHT_PAR);
        b = a;
        break;
      case COMMA:
        jj_consume_token(COMMA);
        b = expr();
        jj_consume_token(RIGHT_PAR);
        break;
      default:
        jj_la1[19] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      trans = affine.scaling(a, b);
      break;
    case TRANS:
      jj_consume_token(TRANS);
      jj_consume_token(LEFT_PAR);
      a = expr();
      jj_consume_token(COMMA);
      b = expr();
      jj_consume_token(RIGHT_PAR);
      trans = affine.translation(a, b);
      break;
    case MATRIX:
      jj_consume_token(MATRIX);
      jj_consume_token(LEFT_PAR);
      a = expr();
      jj_consume_token(COMMA);
      b = expr();
      jj_consume_token(COMMA);
      c = expr();
      jj_consume_token(COMMA);
      d = expr();
      jj_consume_token(RIGHT_PAR);
      trans = affine.matrix(a, b, c, d);
      break;
    case MAP:
      jj_consume_token(MAP);
      jj_consume_token(LEFT_PAR);
      jj_consume_token(LEFT_PAR);
      a = expr();
      jj_consume_token(COMMA);
      b = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(ARROW);
      jj_consume_token(LEFT_PAR);
      a2 = expr();
      jj_consume_token(COMMA);
      b2 = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(COMMA);
      jj_consume_token(LEFT_PAR);
      c = expr();
      jj_consume_token(COMMA);
      d = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(ARROW);
      jj_consume_token(LEFT_PAR);
      c2 = expr();
      jj_consume_token(COMMA);
      d2 = expr();
      jj_consume_token(RIGHT_PAR);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        jj_consume_token(COMMA);
        jj_consume_token(LEFT_PAR);
        e = expr();
        jj_consume_token(COMMA);
        f = expr();
        jj_consume_token(RIGHT_PAR);
        jj_consume_token(ARROW);
        jj_consume_token(LEFT_PAR);
        e2 = expr();
        jj_consume_token(COMMA);
        f2 = expr();
        jj_consume_token(RIGHT_PAR);
        break;
      default:
        jj_la1[20] = jj_gen;
        ;
      }
      jj_consume_token(RIGHT_PAR);
      trans = affineMapping(a, b, a2, b2, c, d, c2, d2, e, f, e2, f2);
      break;
    case SIM:
      jj_consume_token(SIM);
      jj_consume_token(LEFT_PAR);
      jj_consume_token(LEFT_PAR);
      a = expr();
      jj_consume_token(COMMA);
      b = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(ARROW);
      jj_consume_token(LEFT_PAR);
      a2 = expr();
      jj_consume_token(COMMA);
      b2 = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(COMMA);
      jj_consume_token(LEFT_PAR);
      c = expr();
      jj_consume_token(COMMA);
      d = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(ARROW);
      jj_consume_token(LEFT_PAR);
      c2 = expr();
      jj_consume_token(COMMA);
      d2 = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(RIGHT_PAR);
      trans = similarity(a, b, a2, b2, c, d, c2, d2);
      break;
    default:
      jj_la1[21] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return trans;}
    throw new Error("Missing return statement in function");
  }

  final public Object[] operation() throws ParseException {
  list components = new list();
    jj_consume_token(OP_BRACKET_LEFT);
    token_source.SwitchTo(OP_BRACKET_RIGHT_OR_NOT);
    if (token_source.getNextToken().kind != IS_OP_BRACKET_RIGHT) opComponents(components);
    {if (true) return array(components);}
    throw new Error("Missing return statement in function");
  }

  final public ccOperation ccOperation() throws ParseException {
  Token token;
    jj_consume_token(CC);
    jj_consume_token(LEFT_PAR);
    token_source.SwitchTo(RGB_SPEC);
    token = jj_consume_token(RGB);
    jj_consume_token(RIGHT_PAR);
    String spec = "rgb(" + token.image + ")";
    ccOperation result = ccOperation.decode(spec);
    if (result == null) {if (true) throw new ParseException("invalid specification of colour operation in \"" + spec + "\"");}
    else {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public void opComponents(list components) throws ParseException {
    String name = names.nameOrNull();
    if (name != null) {
      transformation t = (transformation)nameTable.get(name);
      if (t == null) {if (true) throw new ParseException("undefined transformation " + name);}
      components.append(t);
    }
    else {
      collage col = new collage();
      collageUnion(col);
      components.append(col);
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      opComponents(components);
      break;
    case OP_BRACKET_RIGHT:
      jj_consume_token(OP_BRACKET_RIGHT);
      break;
    default:
      jj_la1[22] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public affine usedTrans() throws ParseException {
  affine result;
    jj_consume_token(USETRANS);
    jj_consume_token(LEFT_PAR);
    result = transByName();
    jj_consume_token(RIGHT_PAR);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public affine transByName() throws ParseException {
  affine result;
    String n = names.name();
    Object o = nameTable.get(n);
    if (o == null) {if (true) throw new ParseException("Transformation '" + n + "' undefined");}
    {if (true) return (affine)((affine)o).clone();}
    throw new Error("Missing return statement in function");
  }

  final public double expr() throws ParseException {
  double result;
    result = factor();
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 53:
      case 54:
        ;
        break;
      default:
        jj_la1[23] = jj_gen;
        break label_1;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 53:
        jj_consume_token(53);
                            result += factor();
        break;
      case 54:
        jj_consume_token(54);
                                                          result -= factor();
        break;
      default:
        jj_la1[24] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                                                                                     {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public double factor() throws ParseException {
  double result;
    result = basicFactor();
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 55:
      case 56:
        ;
        break;
      default:
        jj_la1[25] = jj_gen;
        break label_2;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 55:
        jj_consume_token(55);
          result *= basicFactor();
        break;
      case 56:
        jj_consume_token(56);
                                             result /= basicFactor();
        break;
      default:
        jj_la1[26] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public double basicFactor() throws ParseException {
  double result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 54:
      jj_consume_token(54);
        {if (true) return -basicFactor();}
      break;
    case USECONST:
      jj_consume_token(USECONST);
    String name = names.name();
    Object d = constTable.get(name);
    if (d == null) {if (true) throw new ParseException("constant " + name + " undefined");}
    {if (true) return ((Double)d).doubleValue();}
      break;
    case SIN:
      jj_consume_token(SIN);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return Math.sin(Math.PI * result / 180.0);}
      break;
    case COS:
      jj_consume_token(COS);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return Math.cos(Math.PI * result / 180.0);}
      break;
    case TAN:
      jj_consume_token(TAN);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return Math.tan(Math.PI * result / 180.0);}
      break;
    case SQRT:
      jj_consume_token(SQRT);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return Math.sqrt(result);}
      break;
    case RAT:
      token = jj_consume_token(RAT);
    try { {if (true) return new Double(token.image).doubleValue();} }
    catch (NumberFormatException e) {
      {if (true) throw new ParseException(token.image+" not a valid number");}
      {if (true) return 0;}
    }
      break;
    case LEFT_PAR:
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return result;}
      break;
    default:
      jj_la1[27] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  public collageAlgebraParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[28];
  final private int[] jj_la1_0 = {0x1fd0200,0x0,0x0,0x7e000000,0x200,0x0,0x8000,0xe000000,0x70000000,0x7e000000,0x800,0x0,0x8000,0x8000,0x0,0x80000000,0x80000000,0x80000000,0x0,0x8100,0x8000,0x1f80000,0x28000,0x0,0x0,0x0,0x0,0xc0,};
  final private int[] jj_la1_1 = {0x34,0x20000,0x90000,0x2,0x10,0x40,0x0,0x0,0x0,0x2,0x0,0x8,0x0,0x0,0x1,0x0,0x1,0x1,0xc000,0x0,0x0,0x20,0x0,0x600000,0x600000,0x1800000,0x1800000,0x400f10,};

  public collageAlgebraParser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new collageAlgebraParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 28; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 28; i++) jj_la1[i] = -1;
  }

  public collageAlgebraParser(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new collageAlgebraParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 28; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 28; i++) jj_la1[i] = -1;
  }

  public collageAlgebraParser(collageAlgebraParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 28; i++) jj_la1[i] = -1;
  }

  public void ReInit(collageAlgebraParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 28; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[57];
    for (int i = 0; i < 57; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 28; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 57; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
