/* Generated By:JavaCC: Do not edit this line. collageAlgebraParser3D.java */
package parsers;

import java.util.*;
import terms.*;
import util.*;
import applications.pictures3D.*;
import javax.media.j3d.*;
import javax.vecmath.Point3d;
import javax.vecmath.Point3f;

/**
 * @author <a href="mailto:ariel@tzi.de">Caroline Diana von Totth</a>
 */

/** The parser class for <code>collageAlgebras</code> in three dimensions.
 * Currently, the following grammar can be parsed:
 * <definition> ::= <parts> | <trans>
 *
 * <trans>      ::=  transformations { <transformation> (, <transformation>)* }
 * <transformation> ::= <name> = <primitive transformation> (. <primitive transformation>)*
 * <primitive transformation> ::=
 *                   scale (<rat> [, <rat>, <rat>]) //a uniform/non-uniform scaling
 *                 | translate <point> 
 *                 | rotate (<rat>, <rat>, <rat>, <rat>) //rotate around vector and angle
 *                 | matrix (<rat>, <rat>, <rat>, <rat>,
 *                           <rat>, <rat>, <rat>, <rat>,
 *                           <rat>, <rat>, <rat>, <rat>,
 *                           <rat>, <rat>, <rat>, <rat> )
 *
 * <parts>      ::=  parts { <part> (, <part>)* }
 * <part>       ::= <name> = <geometry>, <appearance>
 * <geometry>   ::= cube    { <rat>, <rat>, <rat>
 *                  pyramid { <rat>, <rat>, <rat>
 *                  cylinder{ <rat>, <rat>, <rat>
 *                  sphere  { <rat>, <rat>
 *                  polyhedron{ points {<named point> (, <named point>)*},
 *                              polygons{<polygon> (, <polygon>)*}
 *                           [, texcoords{<point> (, <point>)*}]
 * <point>      ::= (<rat>, <rat>, <rat>)
 * <named point>::= <name> = <point>
 * <polygon>    ::= (<name> (, <name>)*) 
 * <appearance> ::=    colour <rgb-colour>
 *                  [, <texture>] }
 * <rgb-colour> ::= [<rat>, <rat>, <rat> [, <rat>]] // (r,g,b, optional alpha value)
 * <texture>    ::= texture [<name> [, mirror] [, <rat>] [, blend]] // mirror, transparency
 *                                                                  // and blending
 *
 *
 *
 * Depending on context, the parantheses, braces and brackets take on different 
 * meanings, so read carefully. ;)
 * 
 */
public class collageAlgebraParser3D implements componentParser, collageAlgebraParser3DConstants {

  private ASCII_CharStream inputStream = null;
  private nameParser names;
  private Hashtable nameTable = new Hashtable();
  private Hashtable constTable = new Hashtable();
  private collageAlgebra alg;


  /**
   * Creates a new <code>collageAlgebraParser3D</code> instance.
   *
   * @param input an <code>ASCII_CharStream</code> value
   * @param alg a <code>collageAlgebra</code> value
   */
  public collageAlgebraParser3D(ASCII_CharStream input, collageAlgebra alg) {
    this(new collageAlgebraParser3DTokenManager(input));
    names = new nameParser(input);
    inputStream = input;
    this.alg = alg;
  }

/** Parse stuff.
 * @exception ParseException if an error occurs
 */
  final public void component() throws ParseException {
  String name = "";
  Object col = new Object();
  Object[] op;
  double d;
  double x, y, z, r, g, b, a;
  int part_type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PARTS:
      jj_consume_token(PARTS);
      jj_consume_token(LEFT_BRACE);
                           name = parts();
      label_1:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[0] = jj_gen;
          break label_1;
        }
        jj_consume_token(COMMA);
              name = parts();
      }
      jj_consume_token(RIGHT_BRACE);
      break;
    case TRANSFORM:
      jj_consume_token(TRANSFORM);
      jj_consume_token(LEFT_BRACE);
                               name = trans();
      label_2:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[1] = jj_gen;
          break label_2;
        }
        jj_consume_token(COMMA);
               name = trans();
      }
      jj_consume_token(RIGHT_BRACE);
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public String trans() throws ParseException {
  Token token;
  String transname;
  Transform3D result = new Transform3D();
  double x, y, z;
  double u, v, w, a;
  int i = 1;
  double[] matrix = new double[16];
    transname = names.name();
    jj_consume_token(EQ);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SCALE:
      jj_consume_token(SCALE);
      jj_consume_token(LEFT_PAR);
       u=v=w=rat();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        jj_consume_token(COMMA);
        v = rat();
        jj_consume_token(COMMA);
        w = rat();
        break;
      default:
        jj_la1[3] = jj_gen;
        ;
      }
      jj_consume_token(RIGHT_PAR);
       result = alg.concat((Transform3D)alg.addScaling(u, v, w), result);
      break;
    case TRANSLATE:
      jj_consume_token(TRANSLATE);
      jj_consume_token(LEFT_PAR);
      u = rat();
      jj_consume_token(COMMA);
      v = rat();
      jj_consume_token(COMMA);
      w = rat();
      jj_consume_token(RIGHT_PAR);
       result = alg.concat((Transform3D)alg.addTranslation(u, v, w), result);
      break;
    case ROTATE:
      jj_consume_token(ROTATE);
      jj_consume_token(LEFT_PAR);
      u = rat();
      jj_consume_token(COMMA);
      v = rat();
      jj_consume_token(COMMA);
      w = rat();
      jj_consume_token(COMMA);
      a = rat();
      jj_consume_token(RIGHT_PAR);
       result = alg.concat((Transform3D)alg.addRotation(u, v, w, a), result);
      break;
    case MATRIX:
      jj_consume_token(MATRIX);
      jj_consume_token(LEFT_PAR);
      u = rat();
            i = 1;
            matrix[0] = u;
            // System.out.println("test1:"+u);

      label_3:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[4] = jj_gen;
          break label_3;
        }
        jj_consume_token(COMMA);
        u = rat();
         matrix[i] = u;
         // System.out.println("test1:"+u);
         i++;
      }
      jj_consume_token(RIGHT_PAR);
       result = alg.concat((Transform3D)alg.addMatrix(matrix), result);
      break;
    case ROTATEP:
      jj_consume_token(ROTATEP);
      jj_consume_token(LEFT_PAR);
      x = rat();
      jj_consume_token(COMMA);
      y = rat();
      jj_consume_token(COMMA);
      z = rat();
      jj_consume_token(COMMA);
      u = rat();
      jj_consume_token(COMMA);
      v = rat();
      jj_consume_token(COMMA);
      w = rat();
      jj_consume_token(COMMA);
      a = rat();
      jj_consume_token(RIGHT_PAR);
       result = alg.concat((Transform3D)alg.addPointRotation(x, y, z, u, v, w, a), result);
      break;
    default:
      jj_la1[5] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case POINT:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_4;
      }
      jj_consume_token(POINT);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SCALE:
        jj_consume_token(SCALE);
        jj_consume_token(LEFT_PAR);
        u=v=w=rat();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          jj_consume_token(COMMA);
          v = rat();
          jj_consume_token(COMMA);
          w = rat();
          break;
        default:
          jj_la1[7] = jj_gen;
          ;
        }
        jj_consume_token(RIGHT_PAR);
        result = alg.concat((Transform3D)alg.addScaling(u, v, w), result);
        break;
      case TRANSLATE:
        jj_consume_token(TRANSLATE);
        jj_consume_token(LEFT_PAR);
        u = rat();
        jj_consume_token(COMMA);
        v = rat();
        jj_consume_token(COMMA);
        w = rat();
        jj_consume_token(RIGHT_PAR);
        result = alg.concat((Transform3D)alg.addTranslation(u, v, w), result);
        break;
      case ROTATE:
        jj_consume_token(ROTATE);
        jj_consume_token(LEFT_PAR);
        u = rat();
        jj_consume_token(COMMA);
        v = rat();
        jj_consume_token(COMMA);
        w = rat();
        jj_consume_token(COMMA);
        a = rat();
        jj_consume_token(RIGHT_PAR);
        result = alg.concat((Transform3D)alg.addRotation(u, v, w, a), result);
        break;
      case MATRIX:
        jj_consume_token(MATRIX);
        jj_consume_token(LEFT_PAR);
        u = rat();
            i = 1;
            matrix[0] = u;
            //System.out.println("test2:"+u);

        label_5:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[8] = jj_gen;
            break label_5;
          }
          jj_consume_token(COMMA);
          u = rat();
         matrix[i] = u;
         // System.out.println("test2:"+u);
         i++;
        }
        jj_consume_token(RIGHT_PAR);
       result = alg.concat((Transform3D)alg.addMatrix(matrix), result);
        break;
      case ROTATEP:
        jj_consume_token(ROTATEP);
        jj_consume_token(LEFT_PAR);
        x = rat();
        jj_consume_token(COMMA);
        y = rat();
        jj_consume_token(COMMA);
        z = rat();
        jj_consume_token(COMMA);
        u = rat();
        jj_consume_token(COMMA);
        v = rat();
        jj_consume_token(COMMA);
        w = rat();
        jj_consume_token(COMMA);
        a = rat();
        jj_consume_token(RIGHT_PAR);
        result = alg.concat((Transform3D)alg.addPointRotation(x, y, z, u, v, w, a), result);
        break;
      default:
        jj_la1[9] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        alg.addTransform(transname, result);
          {if (true) return transname;}
    throw new Error("Missing return statement in function");
  }

  final public String parts() throws ParseException {
    Token  token;
    String partname;
    String pointname;
    String polyname;
    double u = 1;
    double v = 1;
    double w = 1;
    double z = 1;
    double r, g, b;
    double a = 2;
    Object col = new Object();
    int    part_type;
    String tex = "test";
    int    texcoord = 1;   /*used in <code>part3D</code> for choosing 
			   the way texture is applied to an object*/
    double   texalpha = 1; /*transparency of texture*/
    int      blend    = 0;
    Vector   coordinates; //the coordinates themselves, I hope
    int      coordnumber    = 0; /*counter: length of coordinateData*/
    double[] coordinateData = new double[100];
    Vector   polygons;           /*number of points for each polygon*/
    int      poly = 0;
    int[]    polycount  = new int[100];
    int      ptsperpoly = 0;  /*counter: points per polygon*/
    Vector   texCoord;
    float[]  textureCoord = new float[100];
    Hashtable pts;
        partname = names.name();
    jj_consume_token(EQ);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CUBE:
    case PYRAMID:
    case SPHERE:
    case CYLINDER:
    case SMOOTH_CYL:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CUBE:
        jj_consume_token(CUBE);
            part_type = 1;
        break;
      case PYRAMID:
        jj_consume_token(PYRAMID);
            part_type = 2;
        break;
      case SPHERE:
        jj_consume_token(SPHERE);
            part_type = 3;
        break;
      case CYLINDER:
        jj_consume_token(CYLINDER);
            part_type = 4;
        break;
      case SMOOTH_CYL:
        jj_consume_token(SMOOTH_CYL);
            part_type = 5;
        break;
      default:
        jj_la1[10] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(LEFT_BRACE);
      u = rat();
      jj_consume_token(COMMA);
      v = rat();
      jj_consume_token(COMMA);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RAT:
        w = rat();
        jj_consume_token(COMMA);
        break;
      default:
        jj_la1[11] = jj_gen;
        ;
      }
      break;
    case FRUSTUM:
      jj_consume_token(FRUSTUM);
            part_type = 6;
      jj_consume_token(LEFT_BRACE);
      u = rat();
      jj_consume_token(COMMA);
      v = rat();
      jj_consume_token(COMMA);
      w = rat();
      jj_consume_token(COMMA);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RAT:
        z = rat();
        jj_consume_token(COMMA);
        break;
      default:
        jj_la1[12] = jj_gen;
        ;
      }
      break;
    case POLYHEDRON:
      jj_consume_token(POLYHEDRON);
            part_type = 0;
      jj_consume_token(LEFT_BRACE);
      jj_consume_token(POINTS);
      jj_consume_token(LEFT_BRACE);
            pts = new Hashtable();
            pointname = names.name();
      jj_consume_token(EQ);
      jj_consume_token(LEFT_PAR);
      u = rat();
      jj_consume_token(COMMA);
      v = rat();
      jj_consume_token(COMMA);
      w = rat();
      jj_consume_token(RIGHT_PAR);
            pts.put(pointname, new Point3d(u, v, w));
      label_6:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[13] = jj_gen;
          break label_6;
        }
        jj_consume_token(COMMA);
           pointname = names.name();
        jj_consume_token(EQ);
        jj_consume_token(LEFT_PAR);
        u = rat();
        jj_consume_token(COMMA);
        v = rat();
        jj_consume_token(COMMA);
        w = rat();
        jj_consume_token(RIGHT_PAR);
            pts.put(pointname, new Point3d(u, v, w));
      }
      jj_consume_token(RIGHT_BRACE);
      jj_consume_token(COMMA);
      jj_consume_token(POLYGONS);
      jj_consume_token(LEFT_BRACE);
      jj_consume_token(LEFT_PAR);
            polyname    = names.name();
            coordinates = new Vector();
            polygons    = new Vector();
            coordinates.add(pts.get(polyname));
            ptsperpoly++;
            coordnumber++;
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[14] = jj_gen;
          break label_7;
        }
        jj_consume_token(COMMA);
               polyname = names.name();
               coordinates.add(coordnumber, pts.get(polyname));
               ptsperpoly++;
               coordnumber++;
      }
               polygons.add(poly, new Integer(ptsperpoly));
               ptsperpoly = 0;
               poly++;
      jj_consume_token(RIGHT_PAR);
      label_8:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[15] = jj_gen;
          break label_8;
        }
        jj_consume_token(COMMA);
        jj_consume_token(LEFT_PAR);
            polyname = names.name();
            // coordinates = new Vector();
             // coordnumber = 0;
             // polygons = new Vector();
             // poly = 0;
            coordinates.add(coordnumber, pts.get(polyname));
            ptsperpoly++;
            coordnumber++;
        label_9:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[16] = jj_gen;
            break label_9;
          }
          jj_consume_token(COMMA);
               polyname = names.name();
               coordinates.add(coordnumber, pts.get(polyname));
               ptsperpoly++;
               coordnumber++;
        }
               polygons.add(poly, new Integer(ptsperpoly));
               ptsperpoly = 0;
               poly++;
        jj_consume_token(RIGHT_PAR);
      }
      jj_consume_token(RIGHT_BRACE);
                 coordinateData = new double[3*(coordinates.size())];
                 for(int j = 0; j < coordinates.size(); j++ ) {
                   coordinateData[j*3]   = ((Point3d)coordinates.get(j)).x;
                   coordinateData[j*3+1] = ((Point3d)coordinates.get(j)).y;
                   coordinateData[j*3+2] = ((Point3d)coordinates.get(j)).z;
                 }

                 polycount = new int[poly];
                 for (int i = 0; i < poly; i++) {
                   polycount[i] = ((Integer)polygons.get(i)).intValue();
                 }
      if (jj_2_1(2)) {
        jj_consume_token(COMMA);
        jj_consume_token(TEXCOORDS);
        jj_consume_token(LEFT_BRACE);
        jj_consume_token(LEFT_PAR);
        u = rat();
        jj_consume_token(COMMA);
        v = rat();
        jj_consume_token(COMMA);
        w = rat();
                    texCoord = new Vector();
                    texCoord.add(new Point3f((float)u, (float)v, (float)w));
        jj_consume_token(RIGHT_PAR);
        label_10:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[17] = jj_gen;
            break label_10;
          }
          jj_consume_token(COMMA);
          jj_consume_token(LEFT_PAR);
          u = rat();
          jj_consume_token(COMMA);
          v = rat();
          jj_consume_token(COMMA);
          w = rat();
                       texCoord.add(new Point3f((float)u, (float)v, (float)w));
          jj_consume_token(RIGHT_PAR);
        }
                      textureCoord = new float[3*texCoord.size()];
                      for (int j = 0; j < texCoord.size(); j++ ) {
                        textureCoord[j*3] = ((Point3f)texCoord.get(j)).x;
                        textureCoord[j*3+1] = ((Point3f)texCoord.get(j)).y;
                        textureCoord[j*3+2] = ((Point3f)texCoord.get(j)).z;
                      }
        jj_consume_token(RIGHT_BRACE);
      } else {
        ;
      }
      jj_consume_token(COMMA);
      break;
    default:
      jj_la1[18] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(COLOUR);
    jj_consume_token(LEFT_BRACKET);
            r=g=b=col();
    if (jj_2_2(2)) {
      jj_consume_token(COMMA);
      g = col();
      jj_consume_token(COMMA);
      b = col();
    } else {
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      a = rat();
      break;
    default:
      jj_la1[19] = jj_gen;
      ;
    }
    jj_consume_token(RIGHT_BRACKET);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      jj_consume_token(TEXTURE);
      jj_consume_token(LEFT_BRACKET);
                                            tex = names.name();
      if (jj_2_3(2)) {
        jj_consume_token(COMMA);
        jj_consume_token(MIRROR);
                                         texcoord = 2;
      } else {
        ;
      }
      if (jj_2_4(2)) {
        jj_consume_token(COMMA);
        texalpha = rat();
      } else {
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        jj_consume_token(COMMA);
        jj_consume_token(BLEND);
                          blend = 1;
        break;
      default:
        jj_la1[20] = jj_gen;
        ;
      }
      jj_consume_token(RIGHT_BRACKET);
      break;
    default:
      jj_la1[21] = jj_gen;
      ;
    }
          switch (part_type) {
          case 0:
            col = new polyhedron(coordinateData, polycount, textureCoord,
                                 r, g, b, a, tex, texcoord, texalpha, blend);
            break;
          case 1:
            col = new cube(u, v, w, r, g, b, a, tex, texcoord,
                           texalpha, blend);
            break;
          case 2:
            col = new pyramid(u, v, w, r, g, b, a, tex, texcoord,
                              texalpha, blend);
            break;
          case 3:
            col = new sphere(u, v, w, r, g, b, a, tex, texcoord,
                             texalpha, blend);
            break;
          case 4:
            col = new cylinder(u, v, w, r, g, b, a, tex, texcoord,
                               texalpha, blend);
            break;
          case 6:
            col = new frustum(u, v, w, z, r, g, b, a, tex, texcoord,
                               texalpha, blend);
            break;
          }
    jj_consume_token(RIGHT_BRACE);
            if (part_type != 0) {
              alg.addPart3D(partname, col);
            } else {
              alg.addPart3D(partname, col);

            }
          {if (true) return partname;}
    throw new Error("Missing return statement in function");
  }

  final public double rat() throws ParseException {
    Token token;
    Double result;
    token = jj_consume_token(RAT);
      try { {if (true) return new Double(token.image).doubleValue();} }
      catch (NumberFormatException e) {
        {if (true) throw new ParseException("`" + token.image + "' not a valid number");}
      }
    throw new Error("Missing return statement in function");
  }

  final public double col() throws ParseException {
    double c;
    c = rat();
      if (c < 0 || c > 1) {
        {if (true) throw new ParseException("`" + token.image + "' not a valid number");}
      }
      {if (true) return c;}
    throw new Error("Missing return statement in function");
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_3R_11() {
    if (jj_3R_12()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TEXCOORDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_12()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_12() {
    if (jj_scan_token(RAT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(MIRROR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public collageAlgebraParser3DTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[22];
  final private int[] jj_la1_0 = {0x400000,0x400000,0x4040,0x400000,0x400000,0xf8000,0x800000,0x400000,0x400000,0xf8000,0x1780,0x0,0x0,0x400000,0x400000,0x400000,0x400000,0x400000,0x3f80,0x400000,0x400000,0x400000,};
  final private int[] jj_la1_1 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40,0x40,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private JJCalls[] jj_2_rtns = new JJCalls[4];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public collageAlgebraParser3D(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new collageAlgebraParser3DTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 22; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 22; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public collageAlgebraParser3D(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new collageAlgebraParser3DTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 22; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 22; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public collageAlgebraParser3D(collageAlgebraParser3DTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 22; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(collageAlgebraParser3DTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 22; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[39];
    for (int i = 0; i < 39; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 22; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 39; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 4; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
