/* Generated By:JavaCC: Do not edit this line. gridAlgebraParser.java */
package parsers;

import java.util.*;
import terms.*;
import applications.collages.*;
import applications.*;

public class gridAlgebraParser implements componentParser, gridAlgebraParserConstants {

  private ASCII_CharStream inputStream = null;
  private setParser definitions;
  private nameParser names;
  private gridAlgebra alg;
  private Hashtable synonyms = new Hashtable();

  public gridAlgebraParser(ASCII_CharStream input) {
    this(new gridAlgebraParserTokenManager(input));
    names = new nameParser(input);
    definitions = new setParser(input);
    inputStream = input;
  }

/** Parse a <code>gridAlgebra</code>.
  * The syntax consists only of a natural number &gt; 0 which determines the grid size, or
  * a pair whose first component is the grid size and whose second component is a set of
  * equations defining synonyms for standard symbols (given by their names).
  * @exception ParseException if an error occurs
  */
  final public void gridAlgebra(gridAlgebra alg) throws ParseException {
  this.alg = alg;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAT:
      gridSize();
      break;
    case LEFT_PAR:
      jj_consume_token(LEFT_PAR);
      gridSize();
      jj_consume_token(COMMA);
    definitions.set(this);
      jj_consume_token(RIGHT_PAR);
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void component() throws ParseException {
  int rankLhs, rankRhs;
    String lhs = names.name();
    jj_consume_token(EQUALS);
    String rhs = names.name();
    Object rhsOp = alg.decodeOp(rhs);
    if (rhsOp == null) {
      {if (true) throw new ParseException("Cannot introduce a synonym for " + rhs +
                                                  ".\nThis symbol does not denote an allowed operation");}
    }
    if (rhsOp instanceof collage) rankRhs = 0;
    else if (rhsOp instanceof ccOperation) rankRhs = 1;
    else rankRhs = ((affine[])rhsOp).length;
    Object lhsOp = alg.decodeOp(lhs);
    if (lhsOp != null) {
      if (lhsOp instanceof collage) rankLhs = 0;
      else if (lhsOp instanceof ccOperation) rankLhs = 1;
      else rankLhs = ((affine[])lhsOp).length;
      if (rankLhs == rankRhs) {
        {if (true) throw new ParseException("Symbol " + lhs + " of rank " +
                                                   rankLhs + " has a standard meaning." +
                                                   " Such symbols cannot be used as synonyms");}
      }
    }
    symbol synonym = new symbol(lhs, rankRhs);
    if (synonyms.get(synonym)  != null) {
      {if (true) throw new ParseException("Symbol " + lhs + " of rank " + rankRhs +
                                                 " already used as a synonym for " +
                                                 synonyms.get(synonym) + ".\nYou cannot use it" +
                                                 " for " + rhs + " at the same time");}
    }
    synonyms.put(synonym,rhs);
    alg.defineSymbol(synonym, rhsOp);
  }

  final public void gridSize() throws ParseException {
  Token token;
    token = jj_consume_token(NAT);
    try {
      alg.setGridSize(Integer.parseInt(token.image));
    }
    catch (NumberFormatException e) { {if (true) throw new ParseException("Not a valid natural number");} }
  }

  public gridAlgebraParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[1];
  final private int[] jj_la1_0 = {0xc0,};

  public gridAlgebraParser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new gridAlgebraParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 1; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 1; i++) jj_la1[i] = -1;
  }

  public gridAlgebraParser(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new gridAlgebraParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 1; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 1; i++) jj_la1[i] = -1;
  }

  public gridAlgebraParser(gridAlgebraParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 1; i++) jj_la1[i] = -1;
  }

  public void ReInit(gridAlgebraParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 1; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[11];
    for (int i = 0; i < 11; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 1; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 11; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
